<script>
import { save, show, index, destroy } from "@/api/system/baseForm";
import { CreateDialog } from "@/utils/createDialog";
import { deepCopy } from "@/utils";
export default {
  props: {
    formInfo: {
      type: Array,
      default: () => [],
    },
    tableName: String,
  },
  render(h) {
    let dialog = new CreateDialog(this, [
      {
        key: "fangchanzhuangtai",
        label: "房产状态",
        render: h("el-input", {
          props: {
            readonly: true,
            size: "small",
            value: this.originalForm["id_house_properties_land_id_relation"]
              ? "房地权属合一"
              : "房地权属分离",
          },
        }),
      },
      {
        key: "house_relation",
        label: "关联房产",
        rowStyle: {
          "grid-column": "span 2",
        },
        render: h("xy-table", {
          ref: "houseTable",
          props: {
            action: index,
            auths: [],
            reqOpt: {
              table_name: "houses",
            },
            tableItem: [
              {
                type: "selection",
                reserveSelection: true,
                fixed: "left",
                width: 50,
                selectable: (row) => (!row.land_id || row.land_id === this.id),
              },
              {
                label: "名称",
                prop: "name",
                minWidth: 160,
                fixed: "left",
              },
              {
                label: "区域",
                prop: "area",
                width: 80,
                formatter: (data, row, value) => {
                  let map = new Map([
                    [1, "宜兴市"],
                    [2, "惠山区"],
                    [3, "新吴区"],
                    [4, "梁溪区"],
                    [5, "江阴市"],
                    [6, "滨湖区"],
                    [7, "锡山区"],
                  ]);
                  return map.get(value);
                },
              },
              {
                label: "登记面积(m²)",
                prop: "dengjimianji",
                width: 120,
              },
              {
                label: "实际面积(m²)",
                prop: "shijimianji",
                width: 120,
              },
              {
                label: "入账时间",
                prop: "ruzhangshijian",
                width: 160,
              },
              {
                label: "账面原值",
                prop: "zhangmianyuanzhi",
                width: 160,
              },
            ],
          },
          on: {
            ["loaded"]: (_) => {
              //this.setCurrentRow();
              this.$refs["houseTable"].getListData()?.forEach(row => {
                if (row.land_id && row.land_id === this.id)  {
                  this.$refs["houseTable"].toggleRowSelection(row, true);
                }
              })
            },
            ["select"]: (selection, row) => {
              if (row.land_id && row.land_id !== this.id) {
                this.$message({
                  type: "warning",
                  message: "当前房产已有绑定土地",
                });
                this.$refs["houseTable"].toggleRowSelection(row, false);
                return;
              }
            },
            // ["row-click"]: ({ row }) => {
            //   if (row.land_id && row.land_id !== this.id) {
            //     this.$message({
            //       type: "warning",
            //       message: "当前房产已有绑定土地",
            //     });
            //     this.$refs["houseTable"].setCurrentRow();
            //     return;
            //   }
            //   this.form["ruzhangshijian"] = row.ruzhangshijian;
            //   this.form["zhangmianyuanzhi"] = row.zhangmianyuanzhi;
            //   this.pickHouseRow = deepCopy(row);
            //   delete this.pickHouseRow.id_his_evolutions_house_id_relation;
            //   let copyRow = deepCopy(row);
            //   delete copyRow.id;
            //   copyRow.land_id = this.id;
            //   this.form["id_house_properties_land_id_relation"] = [
            //     Object.assign(
            //       this.originalForm?.id_house_properties_land_id_relation
            //         ? this.originalForm.id_house_properties_land_id_relation
            //         : {},
            //       copyRow
            //     ),
            //   ];
            // },
          },
        }),
      },
    ]);
    return dialog.render();
  },
  data() {
    return {
      columns: 1,
      id: "",
      type: "add",
      dialogVisible: false,
      form: {},
      originalForm: {},
      rules: {},
      file: {},

      pickHouseRow: null,
    };
  },
  methods: {
    init() {
      for (let key in this.form) {
        if (this.form[key] instanceof Array) {
          this.form[key] = [];
        } else {
          this.form[key] = "";
        }
      }
      this.$refs["elForm"].clearValidate();
    },
    show() {
      this.dialogVisible = true;
    },
    hidden() {
      this.dialogVisible = false;
    },
    setType(type = "add") {
      let types = ["add", "editor"];
      if (types.includes(type)) {
        this.type = type;
      } else {
        console.warn("Unknown type: " + type);
      }
    },
    setId(id) {
      if (typeof id == "number") {
        this.id = id;
      } else {
        console.error("error typeof id: " + typeof id);
      }
    },

    async getDetail() {
      const res = await show({ id: this.id, table_name: this.tableName });
      this.$integrateData(this.form, res);

      this.formInfo.forEach((i) => {
        if (i && (i.edit_input === "file" || i.edit_input === "files")) {
          res[i._relations.link_with_name]
            ? (this.file[i.field] =
                res[i._relations.link_with_name] instanceof Array
                  ? res[i._relations.link_with_name].map((i) => {
                      return {
                        name: i?.original_name || i?.name,
                        url: i?.url,
                        response: i,
                      };
                    })
                  : [
                      {
                        name: res[i._relations.link_with_name]?.name,
                        url: res[i._relations.link_with_name]?.url,
                        response: res[i._relations.link_with_name],
                      },
                    ])
            : (this.file[i.field] = []);
        }

        this.form = Object.assign({}, this.form);
        this.originalForm = deepCopy(res);
      });
    },

    submit() {
      let promiseAll = [];
      if (this.type === "add") {
        if (this.form.hasOwnProperty("id")) {
          delete this.form.id;
        }
      }
      if (this.type === "editor") {
        Object.defineProperty(this.form, "id", {
          value: this.id,
          enumerable: true,
          configurable: true,
          writable: true,
        });
      }
      this.$refs["elForm"].validate((validate) => {
        if (validate) {
          let copyForm = deepCopy(this.form);
          this.formInfo.forEach((info) => {
            if (
              info._relations?.link_relation === "newHasMany" ||
              info._relations?.link_relation === "hasMany"
            ) {
              if (this.originalForm[info._relations.link_with_name]) {
                this.originalForm[info._relations.link_with_name].map((i) => {
                  promiseAll.push(
                    destroy({
                      id: i.id,
                      table_name: info._relations.link_table_name,
                    })
                  );
                });
              }
            }

            if (copyForm[info._relations?.link_with_name]?.length > 0) {
              delete copyForm[info.field];
            }
            if (
              info._relations?.link_relation === "newHasMany" ||
              info._relations?.link_relation === "hasMany"
            ) {
              if (info.edit_input === "files") {
                copyForm[info._relations.link_with_name] = this.file[
                  info.field
                ]?.map((i) => {
                  let copyRelation = i?.response ? deepCopy(i?.response) : "";
                  delete copyRelation.id;
                  return {
                    upload_id: i?.response?.id,
                    ...copyRelation,
                  };
                });
              } else {
                copyForm[info._relations.link_with_name] = copyForm[
                  info.field
                ]?.map((i) => {
                  let copyRelation = info._params.find(
                    (param) => param[info._relations?.foreign_key] === i
                  )
                    ? deepCopy(
                        info._params.find(
                          (param) => param[info._relations?.foreign_key] === i
                        )
                      )
                    : "";
                  delete copyRelation.id;
                  return {
                    [info._relations.foreign_key]: i,
                    ...copyRelation,
                  };
                });
              }

              delete copyForm[info.field];
            }
            if (
              info._relations?.link_relation === "newHasOne" ||
              info._relations?.link_relation === "hasOne"
            ) {
              if (info.edit_input === "file") {
                copyForm[info._relations.link_with_name] = [
                  {
                    upload_id: this.file[info.field]?.response?.id,
                    ...this.file[info.field],
                  },
                ];
              } else {
                let copyRelation = deepCopy(
                  info._params.find(
                    (param) => param.id == this.form[info.field]
                  )
                );
                if (copyRelation) {
                  delete copyRelation.id;
                  copyForm[info._relations.link_with_name] = [
                    {
                      id: this.form[info._relations?.link_with_name]?.id,
                      [info.field === "shenhebumen"
                        ? "dept_id"
                        : info._relations.foreign_key]: this.form[info.field],
                      ...copyRelation,
                    },
                  ];
                }
              }

              delete copyForm[info.field];
            }
            if (!copyForm[info._relations?.link_with_name]) {
              delete copyForm[info._relations?.link_with_name];
            }
          });
          if (this.$refs["houseTable"].getSelection() && this.$refs["houseTable"]?.getSelection()?.length > 0) {
            promiseAll.push(
              ...this.$refs["houseTable"].getSelection().map(i => save(Object.assign(i, { table_name: 'houses',land_id: this.id, quanzhenghao: copyForm.tudizhenghao, zichanweizhi: copyForm.zichanweizhi })))
            );
          }
          this.originalForm.id_houses_land_id_relation.forEach(item => {
            if (this.$refs["houseTable"].getSelection().findIndex(selected => selected.id === item.id) === -1) {
              promiseAll.push(
                save(Object.assign(item, { table_name: 'houses',land_id: "" }))
              );
            }
          })
          promiseAll.push(
            save(Object.assign(copyForm, { table_name: this.tableName }))
          );
          Promise.all(promiseAll).then((res) => {
            this.$Message.success({
              content: `${this.type === "add" ? "新增" : "编辑"}成功`,
            });
            this.$emit("refresh");
            this.hidden();
          });
        }
      });
    },

    setCurrentRow() {
      this.$nextTick(() => {
        this.$refs["houseTable"].setCurrentRow(
          this.$refs["houseTable"]
            .getListData()
            .find((row) => row.land_id === this.id)
        );
      });
    },
  },
  computed: {},
  watch: {
    formInfo: {
      handler: function (newVal) {
        this.form = {};
        this.rules = {};
        this.file = {};
        newVal.forEach((i) => {
          if (i.field) {
            this.form[i.field] = "";
            if (
              i.validation instanceof Array &&
              i.validation.length > 0 &&
              !!i.validation.find((i) => i === "required")
            ) {
              this.rules[i.field] = [
                { required: true, message: `请填写${i.name}` },
              ];
            }
            if (i.edit_input === "files") {
              this.form[i.field] = [];
            }
            if (i.edit_input === "files" || i.edit_input === "file") {
              this.file[i.field] = [];
            }
            if (i.edit_input === "checkbox") {
              this.form[i.field] = [];
            }
            if (i._relations) {
              this.form[i._relations?.link_with_name] = [];
            }
          }
        });

        this.columns = newVal.length > 11 ? "2" : "1";
      },
      //immediate: true,
    },
    dialogVisible(val) {
      if (val) {
        document.documentElement.style.setProperty(
          "--column-num",
          this.columns
        );
        if (this.type === "editor") {
          this.$nextTick(() => this.getDetail());
        }
      } else {
        this.id = "";
        this.type = "";
        this.init();
        this.$refs["elForm"].clearValidate();
        this.$refs["houseTable"].setCurrentRow();
        delete this.form.id;
        for (let key in this.file) {
          this.file[key] = [];
        }
      }
    },
  },
};
</script>

<style>
:root {
  --column-num: 2;
}
</style>
<style scoped lang="scss">
.uploaded-a {
  color: red;
  text-decoration: none;
  transition: all 0.2s;
}

.uploaded-a:hover {
  color: red;
  text-decoration: underline;
}

.form-body {
  display: grid;
  grid-gap: 10px;
  grid-template-columns: repeat(var(--column-num), 1fr);
}
</style>
